from binascii import unhexlify
from BeautifulSoup import *
from difflib import SequenceMatcher as Fuzzing, get_close_matches
from itertools import islice
from os import getcwd, listdir, makedirs, rename, remove, walk
from os.path import basename, isdir, isfile, join, exists
from random import randint
from shutil import copy2, copytree, rmtree
from struct import unpack, calcsize
from time import sleep
from xbmc import executebuiltin, getInfoLabel
from xbmcgui import Dialog, DialogProgress
import re
import zipfile

def extract(zip,path):
	with zipfile.ZipFile(zip, 'r') as zip:
		zip.extractall(path)

def process_artwork(Game_Directory,ArtworkFolder):
		Source_Poster = join(Game_Directory,'_resources\\artwork\\poster.jpg')
		Source_Thumb = join(Game_Directory,'_resources\\artwork\\thumb.jpg')
		Source_Fanart = join(Game_Directory,'_resources\\artwork\\fanart.jpg')
		Game_TBN = join(Game_Directory,'default.tbn')
		Game_Thumb = join(Game_Directory,'icon.png')
		Game_Fanart = join(Game_Directory,'fanart.jpg')
		_Resource = join(ArtworkFolder,'_resources.zip')
		_Video = join(ArtworkFolder,'_video.zip')
		_Fanart = join(ArtworkFolder,'_fanart.zip')
		
		remove_files_and_folders(Game_Directory)
		
		if isfile(_Resource):
			rando = randint(10, 40)
			pDialog.update(rando,Game_Folder.upper(),Label_3)
			extract(_Resource,Game_Directory)
			if isfile(Source_Poster): copy2(Source_Poster,Game_TBN)
			if isfile(Source_Thumb): copy2(Source_Thumb,Game_Thumb)
			if isfile(Source_Fanart): copy2(Source_Fanart,Game_Fanart)
		
		if Video_Install and isfile(_Video):
			rando = randint(40, 65)
			pDialog.update(rando,Game_Folder.upper(),Label_3)
			extract(_Video,Game_Directory)
		
		if Large_Fanart and isfile(_Fanart):
			rando = randint(70, 90)
			pDialog.update(rando,Game_Folder.upper(),Label_3)
			extract(_Fanart,Game_Directory)
		
		if not Video_Install and not Large_Fanart:
			rando = randint(40, 95)
			pDialog.update(rando,Game_Folder.upper(),Label_3)

		
		pDialog.update(100,Game_Folder.upper(),Label_3)		

def remove_files_and_folders(Sub_Folder):
	To_Remove = [
		'_resources',
		'default.tbn',
		'fanart.jpg',
		'icon.jpg',
		'icon.png'
	]
	
	for Path in To_Remove:
		Full_Path = join(Sub_Folder, Path)
		if isdir(Full_Path):
			rmtree(Full_Path)
		elif isfile(Full_Path):
			remove(Full_Path)

# print("Arguments:", sys.argv)
args = sys.argv[1:] + [0]*3
arg_standalone, Video_Install, Large_Fanart = [int(arg) for arg in args[:3]]
custompath_args_str = args[3:]
Custom_Game_Directories = [arg for arg in custompath_args_str if arg != 0]

dialog = Dialog()
pDialog = DialogProgress()
Working_Directory = getcwd()
ArtworkPath = join(Working_Directory,'Artwork')
Total_Memory = getInfoLabel('System.memory(total_no_mb)')
xbmc.executebuiltin('Dialog.Close(1100)')
xbmc.executebuiltin('Skin.SetBool(MenuVisible)')
global Game_Folder
Large_Fanart = 0
Video_Install = 0
pDialog.update(0) # used to make sure the progress bar is 0
# Labels
if arg_standalone:
	Label_1 = ""
else:
	Label_1 = "Artwork Installer"
Label_2 = "Initialising please wait..."
Label_3 = "Installing"
Label_4 = "Downloading"
Label_6 = "Error"
Label_7 = "Select a valid directory."
Label_9 = "Artwork installed for "
Label_10 = "This folder is empty "
Label_11 = "Downloading latest[CR][B]Artwork Info.txt[/B]"
Game_Directories = []
Game_Directories_E = []
Game_Directories_F = []
Game_Directories_G = []

if not xbmc.getInfoLabel('system.totalspace(E)').split(' ',2)[1] == "Unavailable": Game_Directories_E = [ "E:\\Demos\\", "E:\\Emulators\\", "E:\\Games\\", "E:\\Homebrew\\", "E:\\Ports\\", "E:\\Apps\\", "E:\\Applications\\" ]
if not xbmc.getInfoLabel('system.totalspace(F)').split(' ',2)[1] == "Unavailable": Game_Directories_F = [ "F:\\Demos\\", "F:\\Emulators\\", "F:\\Games\\", "F:\\Homebrew\\", "F:\\Ports\\", "F:\\Apps\\", "F:\\Applications\\" ]
if not xbmc.getInfoLabel('system.totalspace(G)').split(' ',2)[1] == "Unavailable": Game_Directories_G = [ "G:\\Demos\\", "G:\\Emulators\\", "G:\\Games\\", "G:\\Homebrew\\", "G:\\Ports\\", "G:\\Apps\\", "G:\\Applications\\" ]

if arg_standalone:
	Custom_Game_Directories = [ xbmc.getInfoLabel('Skin.String(CustomPath1Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath2Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath3Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath4Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath5Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath6Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath7Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath8Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath9Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath10Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath11Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath12Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath13Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath14Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath15Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath16Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath17Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath18Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath19Selected)'), xbmc.getInfoLabel('Skin.String(CustomPath20Selected)')]

# Check if sources exist and if they do they aren't empty
for dir_check in filter(None, Game_Directories_E + Game_Directories_F + Game_Directories_G + Custom_Game_Directories):
	if exists(dir_check) and listdir(dir_check):
		Game_Directories.append(dir_check)

Artwork_Types = [ "Arcade", "Demos", "Emulators", "Apps", "Games (Custom)", "Homebrew", "Games (JPN)", "Games (NTSC)", "Games (PAL)", "Games (Other)", "Games (Specials)"]
Artwork_List = dialog.select("Artwork Type",sorted([x.upper() for x in Artwork_Types]))
if Artwork_List == -1:
	pass
else:
	RegionFolder = join(ArtworkPath,sorted(Artwork_Types)[Artwork_List])
	if '(' in RegionFolder and ')' in RegionFolder:
		RegionFolder = join(ArtworkPath,RegionFolder.split('(')[1].split(')')[0])
	
	Normalized_Directories = sorted([x.lower() for x in listdir(RegionFolder)])

	FolderContent = dialog.select("AVAILABLE ARTWORK\n{}".format(sorted(Artwork_Types)[Artwork_List].upper()),[x.upper() for x in Normalized_Directories])

	if FolderContent == -1:
		pass
	else:
		FolderContent = join(RegionFolder,Normalized_Directories[FolderContent])
		
		Normalized_Directories = sorted([x.lower() for x in Game_Directories])
		
		GameDirectory = dialog.select("AVAILABLE SOURCES",[x.upper() for x in Normalized_Directories])
		
		if GameDirectory == -1:
			pass
		else:
			Game_Folder = basename(FolderContent.upper())
			GameDirectory = Normalized_Directories[GameDirectory]
			
			Normalized_Directories = sorted([x.lower() for x in listdir(GameDirectory)])
			
			GameFolderContent = dialog.select("SELECTED ARTWORK\n{}".format(Game_Folder),[x.upper() for x in [x.upper() for x in Normalized_Directories]])
			if GameFolderContent == -1:
				pass
			else:
				GameFolderContent = join(GameDirectory,Normalized_Directories[GameFolderContent])
				if isfile(join(GameFolderContent,'default.xbe')):
					pDialog.create(Label_1,"",Label_2)
					if int(Total_Memory) > 64 and getInfoLabel('Skin.HasSetting(ArtworkInstallerFanart)'):
						Large_Fanart = 1
					else:
						executebuiltin('Skin.Reset(ArtworkInstallerFanart)')
					if getInfoLabel('Skin.HasSetting(ArtworkInstallerVideo)'):
						Video_Install = 1
					process_artwork(GameFolderContent,FolderContent)
					sleep(0.5)
					pDialog.close()
					dialog.ok(Label_1,"",Label_9+Game_Folder)

				else:
					dialog.ok('ERROR','',"Select a valid directory.")


xbmc.executebuiltin('Skin.Reset(MenuVisible)')